;Copyright (C) 2004-2005 John T. Haller
;Copyright (C) 2006 Rob Loach (http://www.robloach.net)
;Copyright (C) 2006 Tuxmouraille
;----------------------------------------------------
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
; ----------------------------------------------------
; Portable CDex
; ----------------------------------------------------
; Par Tuxmouraille
; D'aprs le script de John Haller
; License : GPL
; Ce script permet de crer Portable CDex.
; Ce script est  compiler avec NSIS de Nullsoft (http://www.nullsoft.com).
; Il ncessite les plugins "ipicsplash" (affichage splashscreen) et "CreateMutex_plug-in" 
; (empche les multiinstances) pour tre compil.
; $id=PortableCDex.nsi $date=2006-03-13
; ----------------------------------------------------
; Gnral
!define NAME "Portable7zip"
!define FRIENDLYNAME "version franaise"
!define APP "7zip"
!define VER "0.3.0.4"
!define WEBSITE "http://wiki.framasoft.info/Portables"
!define DEFAULTEXE "7zFM.exe"
!define DEFAULTAPPDIR "7zip"
!define DEFAULTSETTINGSDIR "settings"
!define DEFAULTBACKUPDIR "settings\backup"
!define MYCOMMENTS "Permet  ${APP} d'tre utilis depuis un media amovible. Pour plus d'information, visitez ${WEBSITE}"
!define MYEXEMESSAGE "${DEFAULTEXE} n'est pas prsent. S'il vous plait vrifiez votre configuration"
!define MYMUTEXMESSAGE "${NAME} est dj lanc."

;=== Program Details
Name "${NAME}"
OutFile "${NAME}.exe"
Caption "${NAME}"
VIProductVersion "${VER}"
VIAddVersionKey FileDescription "${FRIENDLYNAME}"
VIAddVersionKey LegalCopyright "GPL"
VIAddVersionKey Comments "${MYCOMMENTS}"
VIAddVersionKey CompanyName "par Tuxmouraille et al"
VIAddVersionKey OriginalFilename "${NAME}.exe"
VIAddVersionKey FileVersion "${VER}"

;=== Runtime Switches
CRCCheck On
WindowIcon Off
SilentInstall Silent
AutoCloseWindow True

;=== Program Icon
Icon "${APP}.ico"

!include "Registry.nsh"
!include "Sections.nsh"

Var PROGRAMDIRECTORY
Var SETTINGSDIRECTORY
Var BACKUPDIRECTORY
Var ADDITIONALPARAMETERS
Var EXECSTRING
Var WAITFORPROGRAM
Var PROGRAMEXECUTABLE
Var INIPATH
Var DISABLESPLASHSCREEN

Section "Main"
	;=== Find the INI file, if there is one
		IfFileExists "$EXEDIR\${NAME}.ini" "" CheckSubINI
			StrCpy "$INIPATH" "$EXEDIR\"
			Goto ReadINI

	CheckSubINI:
		IfFileExists "$EXEDIR\${NAME}\${NAME}.ini" "" CheckSubSubINI
			StrCpy "$INIPATH" "$EXEDIR\${NAME}\"
			Goto ReadINI

	CheckSubSubINI:
		IfFileExists "$EXEDIR\PortableApps\${NAME}\${NAME}.ini" "" CheckPortableAppsINI
			StrCpy "$INIPATH" "$EXEDIR\PortableApps\${NAME}\"
			Goto ReadINI

	CheckPortableAppsINI:
		IfFileExists "$EXEDIR\Apps\${NAME}\${NAME}.ini" ""  NoINI
			StrCpy "$INIPATH" "$EXEDIR\Apps\${NAME}\"
			Goto ReadINI

	ReadINI:
		;=== Read the parameters from the INI file
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "${APP}Directory"
		StrCpy "$PROGRAMDIRECTORY" "$EXEDIR\$0"
        ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "SettingsDirectory"
		StrCpy "$SETTINGSDIRECTORY" "$0"
        ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "BackupDirectory"
		StrCpy "$BACKUPDIRECTORY" "$0"
	

		;=== Check that the above required parameters are present
		IfErrors NoINI

		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "AdditionalParameters"
		StrCpy "$ADDITIONALPARAMETERS" $0
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "WaitFor${APP}"
		StrCpy "$WAITFORPROGRAM" $0
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "${APP}Executable"
		StrCpy "$PROGRAMEXECUTABLE" $0
        ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "DisableSplashScreen"
		StrCpy "$DISABLESPLASHSCREEN" $0
		
		
		;=== Any missing unrequired INI entries will be an empty string, ignore associated errors
		ClearErrors

		;=== Correct PROGRAMEXECUTABLE if blank
		StrCmp $PROGRAMEXECUTABLE "" "" EndINI
			StrCpy "$PROGRAMEXECUTABLE" "${DEFAULTEXE}"
			Goto EndINI

	NoINI:
		;=== No INI file, so we'll use the defaults
		StrCpy "$ADDITIONALPARAMETERS" ""
		StrCpy "$WAITFORPROGRAM" "false"
		StrCpy "$PROGRAMEXECUTABLE" "${DEFAULTEXE}"

		IfFileExists "$EXEDIR\${DEFAULTAPPDIR}\${DEFAULTEXE}" "" CheckPortableProgramDIR
			StrCpy "$PROGRAMDIRECTORY" "$EXEDIR\${DEFAULTAPPDIR}"
            StrCpy "$SETTINGSDIRECTORY" "$EXEDIR\${DEFAULTSETTINGSDIR}"
            StrCpy "$BACKUPDIRECTORY" "$EXEDIR\${DEFAULTBACKUPDIR}"
			Goto EndINI

		CheckPortableProgramDIR:
			IfFileExists "$EXEDIR\${NAME}\${DEFAULTAPPDIR}\${DEFAULTEXE}" "" CheckPortableAppsDIR
			StrCpy "$PROGRAMDIRECTORY" "$EXEDIR\${NAME}\${DEFAULTAPPDIR}"
 			StrCpy "$SETTINGSDIRECTORY" "$EXEDIR\${NAME}\${DEFAULTSETTINGSDIR}"
            StrCpy "$BACKUPDIRECTORY" "$EXEDIR\${NAME}\${DEFAULTBACKUPDIR}"
			Goto EndINI

		CheckPortableAppsDIR:
			IfFileExists "$EXEDIR\PortableApps\${NAME}\${DEFAULTAPPDIR}\${DEFAULTEXE}" "" CheckPortableAppsSplitDIR
			StrCpy "$PROGRAMDIRECTORY" "$EXEDIR\PortableApps\${NAME}\${DEFAULTAPPDIR}"
            StrCpy "$SETTINGSDIRECTORY" "$EXEDIR\PortableApps\${NAME}\${DEFAULTSETTINGSDIR}"
            StrCpy "$BACKUPDIRECTORY" "$EXEDIR\PortableApps\${NAME}\${DEFAULTBACKUPDIR}"
			Goto EndINI

		CheckPortableAppsSplitDIR:
			IfFileExists "$EXEDIR\Apps\${NAME}\${DEFAULTAPPDIR}\${DEFAULTEXE}" "" NoProgramEXE
			StrCpy "$PROGRAMDIRECTORY" "$EXEDIR\Apps\${NAME}\${DEFAULTAPPDIR}"
            StrCpy "$SETTINGSDIRECTORY" "$EXEDIR\Apps\${NAME}\${DEFAULTSETTINGSDIR}"
            StrCpy "$BACKUPDIRECTORY" "$EXEDIR\Apps\${NAME}\${DEFAULTBACKUPDIR}"
			Goto EndINI	

	EndINI:
		IfFileExists "$PROGRAMDIRECTORY\$PROGRAMEXECUTABLE" FoundProgramEXE

	NoProgramEXE:
		;=== Program executable not where expected
		MessageBox MB_OK|MB_ICONEXCLAMATION `${MYEXEMESSAGE}`
		Abort

	FoundProgramEXE:
		StrCmp $DISABLESPLASHSCREEN "true" SkipSplashScreen
			;=== Show the splash screen before processing the files
			InitPluginsDir
			File /oname=$PLUGINSDIR\splash.jpg "${NAME}.jpg"
			ipicsplash::show 3000 600 400 0x04025C "$PLUGINSDIR\splash.jpg"

    SkipSplashScreen:
		;=== Get any passed parameters
		Call GetParameters
		Pop $0
		StrCmp "'$0'" "''" "" LaunchProgramParameters

		;=== No parameters
		StrCpy $EXECSTRING `"$PROGRAMDIRECTORY\$PROGRAMEXECUTABLE"`
		Goto LaunchNow

	LaunchProgramParameters:
		StrCpy $EXECSTRING `"$PROGRAMDIRECTORY\$PROGRAMEXECUTABLE" $0`

    LaunchNow:
      ;== Copy existing files to backup
        ${registry::SaveKey} "HKEY_CURRENT_USER\Software\7-zip" "$BACKUPDIRECTORY\7-zip.reg" "/G=1 /D=2"  $R0
        ${registry::DeleteKey} "HKEY_CURRENT_USER\Software\7-zip" $R0
        
      ;== Restorythekeys
        ${registry::RestoreKey} "$SETTINGSDIRECTORY\7-zip.reg" $R0
    
    ;== Launch the application - Wait so that it can save the keys after exiting
		ExecWait $EXECSTRING

		;== Save and delete the keys
		${registry::SaveKey} "HKEY_CURRENT_USER\Software\7-zip" "$SETTINGSDIRECTORY\7-zip.reg" "/G=1 /D=2" $R0
		${registry::DeleteKey} "HKEY_CURRENT_USER\Software\7-zip" $R0
		
      ;== Restoring the local 7zip's keys
        ${registry::RestoreKey} "$BACKUPDIRECTORY\7-zip.reg" $R0
        
      ;== Deleting backup file
        Delete "$BACKUPDIRECTORY\7-zip.reg"

SectionEnd

Section .onInit
  Call Mutex
SectionEnd

Function "GetParameters"
  Push $R0
  Push $R1
  Push $R2
  StrCpy $R0 $CMDLINE 1
  StrCpy $R1 '"'
  StrCpy $R2 1
  StrCmp $R0 '"' loop
    StrCpy $R1 ' ' ; we're scanning for a space instead of a quote
  loop:
    StrCpy $R0 $CMDLINE 1 $R2
    StrCmp $R0 $R1 loop2
    StrCmp $R0 "\" "" "nofile"
      IntOp $2 $R2 + 1
    nofile:
    ;MessageBox MB_OK "r0: $R0"
    StrCmp $R0 "" loop2
    IntOp $R2 $R2 + 1
    Goto loop
  loop2:
    IntOp $R0 $R2 - $2
    IntOp $R0 $R0 - 4
    ;MessageBox MB_OK "$R2 - $2 = $R0"
    StrCpy $R7 $CMDLINE $R0 $2 ; we save the filename
    ;MessageBox MB_OK "$2"
  loop2b:
    IntOp $R2 $R2 + 1
    StrCpy $R0 $CMDLINE 1 $R2
    ;MessageBox MB_OK "rr0: $R0"
    StrCmp $R0 " " loop2b
  StrCpy $R0 $CMDLINE "" $R2
  Pop $R2
  Pop $R1
  Exch $R0
FunctionEnd

; -------------------------------------------
; Prvenir plusieurs Instances
; Sources : http://www.veekee.net/wikinsis/docs/AppendiceC.html#C.11
; -------------------------------------------
  Function Mutex
  System::Call 'kernel32::CreateMutexA(i 0, i 0, t "myMutex") i .r1 ?e'
  Pop $R0

  StrCmp $R0 0 +3
   MessageBox MB_OK|MB_ICONEXCLAMATION "${MYMUTEXMESSAGE}"
   Abort
  FunctionEnd

; -------------------------------------------
; Fin du script